#ifndef UltimateSOA_H
#define UltimateSOA_H

#include<vector>
#include <tuple>
#include <utility>
#include <type_traits>
#include "align_allocator.h"
#include "SoaIterator.h"


struct Vect {
  float x,y,z;
    
  using value = typename std::remove_const<typename std::remove_reference<T>::type>::type;
  using ref = typename std::add_lvalue_reference<T>::type;
  using REF = Vect<ref>;
  using VAL = Vect<value>;
  using SOATUPLE = std::tuple<
    UltimateSoa<float>,
    UltimateSoa<float>,
    UltimateSoa<float>
  >;
      
}

UltimateSoa< Vect<float> > v(10);   // ten vectors

template<typename T>
struct Traits {
  using VAL =  typename T::VAL;
  using CREF = typename T::CREF;
  using REF =  typename T::REF;
  using SOATUPLE = typename T::SOATUPLE;
};

// notice the !
template<typename T, bool=!std::is_arithmetic<T>::value>
class UltimateSoa {};


// non-arithmetic types will get the storage as defined by SOATUPLE
// that is - a tuple containing the arithmetic storage
template<typename T>
class UltimateSoa<T, true> {
public:
  using VAL =  typename Traits<T>::VAL;
  using CREF = typename Traits<T>::CREF;
  using REF =  typename Traits<T>::REF;
  using Data = typename Traits<T>::SOATUPLE;

  using value_type = VAL;

    // resize...
   template<std::size_t... I>
   void resize_impl(unsigned int n, std::index_sequence<I...>) { 
     using swallow = int[];
     (void)swallow{0, 
                   ((void)(
                     std::get<I>(m_data).resize(n)
                     ),0
                   )... };
   }
  void resize(unsigned int n) {
    resize_impl(n,
     std::make_integer_sequence<std::size_t,std::tuple_size<Data>::value>{}
    );
  }
  
  UltimateSoa(){}
  explicit UltimateSoa(unsigned int n) {
     resize(n);
  }


  template<typename V, std::size_t... I>
  V t2r_impl(unsigned int j, std::index_sequence<I...>) {
    return V(std::get<I>(m_data)[j] ...); // returns the j-th element in the I-th tuple member
  }

  REF operator[](unsigned int j) {
    return t2r_impl<REF>(
        j,
        std::make_integer_sequence<
            std::size_t, std::tuple_size<Data>::value
        >{} // returns a sequence of numbers form 0 to the size of the Data tuple
        );
  }

  Data m_data; // say - 3 tuples of float

};


template<typename T> using AVector = std::vector<T,align_allocator<T,32>>;

// arithmetic types will get the AVector storage
template<typename T>
class UltimateSoa<T, false> : public AVector<T> {
public:
  
  using value = typename std::remove_reference<T>::type;
  using ref = typename std::add_lvalue_reference<T>::type;
  using cref = typename std::add_lvalue_reference<typename std::add_const<T>::type>::type;
  using VAL = value;
  using CREF = cref;
  using REF = ref;
  using value_type = VAL;

  using Storage = AVector<T>;

  template<typename ... Args>
  UltimateSoa(Args... args) : Storage(args...){}
  // initializes:
  // std::vector<float>(10);


};

#endif
