#ifndef UltimateSOA_H
#define UltimateSOA_H

#include<vector>
#include <tuple>
#include <utility>
#include <type_traits>
#include "align_allocator.h"
#include "SoaIterator.h"

template<typename T>
struct Vector3 {
  T  x, y, z;
  Vector3(T _x, T _y, T _z)
    : x(_x), y(_y), z(_z) {}
};

// 3D vectors will get the storage as defined by SOATUPLE
// that is - a tuple containing the arithmetic storage types
class Container {
public:

  using Data = std::tuple<
    std::vector<float>,
    std::vector<float>,
    std::vector<float>
  >;
  
  Data data;

  Container(){}
  explicit Container(int n) {
    // resize each data for each component
    resize(n);
  }

  auto operator[](unsigned int i) {
    return Vector3<float&>
              (std::get<0>(data)[i],
               std::get<1>(data)[i],
               std::get<2>(data)[i]);
  }

};

Container v(10);   // ten vectors

Vector3<float> a(1,2,3);

v[1] = a;

#endif
